﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SampleGame
{
    public partial class MainPage : UserControl
    {
        Storyboard storyboard;

        public static int gameFrame; // 프레임 카운터

        public static GameEngine gameEngine;
        GameProcess gameProcess;

        bool isSocialDataLoadComplete;

        public MainPage()
        {
            InitializeComponent();

            gameEngine = new GameEngine(this, LayoutRoot, GameCanvas);

            storyboard = new Storyboard();
            storyboard.Duration = TimeSpan.FromMilliseconds(16);
            storyboard.Completed += new EventHandler(GameLoop);
            storyboard.Begin();

            gameFrame = 0;

            gameProcess = new GameProcess();
            gameProcess.Init();

            isSocialDataLoadComplete = false;
            //isSocialDataLoadComplete = true; // Opensocial API 사용 없이 게임만 돌릴 경우
        }

        public void GameLoop(object sender, EventArgs e)
        {
            if (!isSocialDataLoadComplete)
            {
                if (SocialData.Pulse() == true)
                {
                    isSocialDataLoadComplete = true;
                }
                else
                {
                    isSocialDataLoadComplete = false;
                    gameEngine.DrawBegin();//드로잉 초기화

                    gameProcess.Pulse(); //마우스/연산처리
                    gameProcess.Render();//드로잉

                    gameFrame++;
                }
            }
            else
            {
                gameEngine.DrawBegin();//드로잉 초기화

                gameProcess.Pulse(); //마우스/연산처리
                gameProcess.Render();//드로잉

                gameFrame++;
            }
            storyboard.Begin();
        }

        public void SocialDataLoad()
        {
            if(SocialData.Pulse() == true)
            {
                isSocialDataLoadComplete = true;
            }
        }
    }
}
