﻿using System.Windows.Media.Imaging;
using System.Windows.Controls;
using System;
using System.Windows;

namespace SampleGame
{
    enum RES
    {
        NONE,
        GameRes,
    }

    class CRes
    {
        public static Image blockRed, blockYellow, blockGreen, blockBlue, blockPurple;
        public static Image blockSelect;
        public static MediaElement sound1;

        public static void LoadRes(RES type)
        {
            switch(type)
            {
                case RES.GameRes:
                    blockRed = LoadImage("red.png");
                    blockYellow = LoadImage("yellow.png");
                    blockGreen = LoadImage("green.png");
                    blockBlue = LoadImage("blue.png");
                    blockPurple = LoadImage("purple.png");
                    blockSelect = LoadImage("select.png");

                    sound1 = LoadSound("sound1.mp3");
                    break;
            }
        }

        public static void ReleaseRes(RES type)
        {
            switch(type)
            {
                case RES.GameRes:
                    blockRed = null;
                    blockYellow = null;
                    blockGreen = null;
                    blockBlue = null;
                    blockPurple = null;
                    blockSelect = null;

                    sound1 = null;
                    break;
            }
        }

        public static Image LoadImage(string filename)
        {
            Image image = new Image();

            BitmapImage bi = new BitmapImage();
            bi.UriSource = new Uri("/SampleGame;component/RES/" + filename, UriKind.Relative);
            System.Windows.Resources.StreamResourceInfo sri = Application.GetResourceStream(bi.UriSource);
            bi.SetSource(sri.Stream);
            image.Source = bi;

            return image;
        }

        public static MediaElement LoadSound(string filename)
        {
            MediaElement sound = new MediaElement();
            sound.Source = new Uri("/SampleGame;component/RES/" + filename, UriKind.Relative);
            return sound;
        }
    }
}